
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Red
#property indicator_color2  White
#property indicator_color3  Red
#property indicator_color4  White
#property indicator_color5  Gold
#property indicator_color6  Blue
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2

//
//
//
//
//

extern int Ma1Period = 10;
extern int Ma1Mode   = MODE_EMA;
extern int Ma1Price  = PRICE_CLOSE;
extern int Ma2Period = 50;
extern int Ma2Mode   = MODE_EMA;
extern int Ma2Price  = PRICE_CLOSE;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double ma1[];
double ma2[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ma1);
   SetIndexBuffer(5,ma2);
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);   
          
   //
   //
   //
   //
   //
   
   for(pos=limit; pos >= 0; pos--)
   {
      double haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
      double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
      double haHigh  = MathMax(High[pos],MathMax(haOpen,haClose));
      double haLow   = MathMin(Low[pos], MathMin(haOpen,haClose));
          
      if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
      else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                            Buffer3[pos]=haOpen;
                            Buffer4[pos]=haClose;   
      ma1[pos] = iMA(NULL,0,Ma1Period,0,Ma1Mode,Ma1Price,pos);    
      ma2[pos] = iMA(NULL,0,Ma2Period,0,Ma2Mode,Ma2Price,pos);   
   }  
return(0);
}

